const loader = document.querySelector('.loading');
const countryName = document.getElementById('name')
const region = document.getElementById('region')
const subregion = document.getElementById('subregion')
const capital = document.getElementById('capital')
const flag = document.getElementById('flag')
const button = document.getElementById('show')
const userInput = document.getElementById('country_name')
const infoToshow = document.querySelector('.show');
let name_to_find = 'Kazakhstan'


const request = (config) => {
    loader.style.display = 'flex'
    const { method, path, success, error } = config;
    const xml = new XMLHttpRequest();
    console.log(name_to_find, config.path)
    xml.addEventListener('load', () => {
        if (xml.status < 200 || xml.status > 399) {
            if (xml.status === 404) {
                error('No country with such name!');
            }
            else {
                error('bad response');
            }

            return;
        }
        else if (xml.status === '404') {
            console.log(xml.status);
        }
        const result = JSON.parse(xml.responseText);
        success(result)
    });
    loader.style.display = 'none'
    xml.addEventListener('error', () => {
        error('network error');
    })
    xml.addEventListener('timeout', () => {
        error('server response is late')
    })
    xml.open(method, path);
    xml.send();
}

const processResult = (result) => {

    const items = createTree(result[0])
    infoToshow.append(items)
    loader.style.display = 'none'
}

const errorHandler = (msg) => {
    alert(msg)
    console.error(msg)
}


const createTree = (data) => {
    console.log(data);
    const ul = document.createElement('ul')
    for (item in data) {
        const li = document.createElement('li')
        if (Array.isArray(data)) {
            if (typeof data[item] === 'object') {
                const innerUl = createTree(data[item])
                li.append(innerUl)
            } else {
                li.append(`${data[item]}`)
            }
        } else {
            if (Array.isArray(data[item])) {
                li.innerHTML = `<b>${item}:</b> \n`
                const innerUl = createTree(data[item])
                li.append(innerUl)
            } else {
                if ((typeof data[item] === 'object')) {
                    li.innerHTML = `<b>${item}:</b> \n`
                    const innerUl = createTree(data[item])
                    li.append(innerUl)
                } else {
                    li.innerHTML = `<b>${item}:</b> ${data[item]}`
                }
                
            }
        }
        ul.append(li)

    }
    return ul
}


const createTreefromObject = (data) => {
    const ul = document.createElement('ul')
    for (item in data) {
        const li = document.createElement('li')
        if (Array.isArray(data[item])) {
            li.append(`${item}: `)
            const innerUl = createTree(data[item])
            li.append(innerUl)
        } else {
            li.append(`${item}: ${data[item]}`)
        }
        ul.append(li)
    }
    return ul
}

const showInfo = () => {
    if (userInput.value) {
        name_to_find = userInput.value
    }
    const config = {
        method: "GET",
        path: `https://restcountries.com/v2/name/${name_to_find}`,
        success: processResult,
        error: errorHandler
    }
    request(config);
    infoToshow.style.display = 'block'
}
button.addEventListener('click', showInfo)
